if (requireNamespace("tinytest", quietly=TRUE)) {

  ## Set a seed to make the test deterministic
  set.seed(42)
  Sys.setenv("R_TESTS"="")

  ## there are several more granular ways to test files in a tinytest directory,
  ## see its package vignette; tests can also run once the package is installed
  ## using the same command `test_package(pkgName)`, or by director or file
  tinytest::test_package("geometries")
}

x <- 1:5
df <- data.frame(
  x = 1:5
  , y = 1:5
  , z = 1:5
)
m <- as.matrix( df )
ldf <- as.list( df )

expect_error( geometries:::.test_to_geometry_matrix_cols( list(), 0L ), "geometries - 0-length list found" )
expect_error( geometries:::.test_to_geometry_matrix_cols( list(1), 2L ), "geometries - invalid column index")
expect_error( geometries:::.test_to_geometry_matrix_cols( list(1), c(1L,2L) ), "geometries - number of columns requested is greater than those available")

expect_error( geometries:::.test_to_geometry_matrix_cols( matrix(T), 0L ), "geometries - lines need to be matrices or data.frames" )

expect_error( geometries:::.test_to_geometry_matrix_single( list() ), "geometries - 0-length list found" )
expect_equal( geometries:::.test_to_geometry_matrix_single( x ), matrix( x, ncol = length( x ) ) )
expect_equal( geometries:::.test_to_geometry_matrix_single( c(x, 1.1) ), matrix( c(x, 1.1), ncol = length( x ) + 1 ) )
expect_equal( geometries:::.test_to_geometry_matrix_single( m ), m )

expect_equal( geometries:::.test_to_geometry_matrix_cols( df, NULL ), unname( m ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( df, NULL ), unname( m ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( df, c(0L,1L,2L) ), unname( m ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( df, c(1L,2L) ), unname( m[, 2:3] ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( df, c("x","y","z") ), unname( m ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( df, c("z","x") ), unname( m[, c(3,1)] ) )

expect_error( geometries:::.test_to_geometry_matrix_cols( 1L:5L, c("x") ), "geometries - lines need to be matrices or data.frames" )
expect_error( geometries:::.test_to_geometry_matrix_cols( c(1.1,2), c("x") ), "geometries - lines need to be matrices or data.frames" )

expect_error( geometries:::.test_to_geometry_matrix_cols_names( df, c(0L,1L,2L,3L), FALSE ), "geometries - number of columns requested is greater than those available" )
expect_error( geometries:::.test_to_geometry_matrix_cols_names( df, c(3L), FALSE ), "geometries - invalid column index" )


expect_equal( geometries:::.test_to_geometry_matrix_cols( m, NULL ), m )  ## a named matrix keeps its names
expect_equal( geometries:::.test_to_geometry_matrix_cols( m, c(0L,1L,2L) ), unname( m ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( m, c(1L,2L) ), unname( m[, 2:3] ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( m, c("x","y","z") ), unname( m ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( m, c("z","x") ), unname( m[, c(3,1)] ) )



expect_equal( geometries:::.test_to_geometry_matrix_cols( ldf, NULL ), unname( m ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( ldf, c(0L,1L,2L) ), unname( m ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( ldf, c(1L,2L) ), unname( m[, 2:3] ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( ldf, c("x","y","z") ), unname( m ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( ldf, c("z","x") ), unname( m[, c(3,1)] ) )

expect_error( geometries:::.test_to_geometry_matrix_cols( df, list() ), "geometries - unknown column types" )


## make it numeric
m[1,1] <- 1.1
expect_equal( geometries:::.test_to_geometry_matrix_cols( m, NULL ), m )  ## a named matrix keeps its names
expect_equal( geometries:::.test_to_geometry_matrix_cols( m, c(0L,1L,2L) ), unname( m ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( m, c(1L,2L) ), unname( m[, 2:3] ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( m, c("x","y","z") ), unname( m ) )
expect_equal( geometries:::.test_to_geometry_matrix_cols( m, c("z","x") ), unname( m[, c(3,1)] ) )

m <- matrix(c(1L,1L,2L,2L,3L,3L), ncol = 2, byrow = T)
l <- list(m)
res <- geometries:::rcpp_close_matrix(l)
expect_equal( res[[1]], rbind(m, c(1L,1L) ) )

m <- matrix(c(1,1,2,2,3,3), ncol = 2, byrow = T)
l <- list(m)
res <- geometries:::rcpp_close_matrix(l)
expect_equal( res[[1]], rbind(m, c(1,1) ) )

m <- matrix(c(1,1,2,2,3,3), ncol = 2, byrow = T)
l <- list(m)
l <- list(l)
res <- geometries:::rcpp_close_matrix(l)
expect_equal( res[[1]][[1]], rbind(m, c(1,1) ) )

m <- matrix(c(1,1,2,2,3,3), ncol = 2, byrow = T)
l <- list(m)
l <- list(l)
l <- list(l)
res <- geometries:::rcpp_close_matrix(l)
expect_equal( res[[1]][[1]][[1]], rbind(m, c(1,1) ) )

m <- matrix(c(1,1,2,2,3,3), ncol = 2, byrow = T)
df <- as.data.frame( m )
l <- list( df )
expect_error( geometries:::rcpp_close_matrix(l) )

## Too few rows
m <- matrix(c(1,1,2,2), ncol = 2, byrow = T)
l <- list(m)
expect_error( geometries:::rcpp_close_matrix(l), "geometries - closed shapes must have at least 4 rows" )

## already closed
m <- matrix(c(1,1,2,2,3,3,1,1), ncol = 2, byrow = T)
l <- list(m)
res <- geometries:::rcpp_close_matrix(l)
expect_equal( res[[1]], m )

m <- matrix(1:4, ncol = 2)
l1 <- list( m )
l2 <- list( l1 )
l3 <- list( l2 )
l4 <- list( l3 )
l5 <- list( l4 )

res <- geometries:::gm_dimensions( m )
expect_true( res$max_nest == 0 )

res <- geometries:::gm_dimensions( l1 )
expect_true( res$max_nest == 1 )

res <- geometries:::gm_dimensions( l2 )
expect_true( res$max_nest == 2 )

res <- geometries:::gm_dimensions( l3 )
expect_true( res$max_nest == 3 )

res <- geometries:::gm_dimensions( l4 )
expect_true( res$max_nest == 4 )

res <- geometries:::gm_dimensions( l5 )
expect_true( res$max_nest == 5 )


expect_equal( geometries:::rcpp_nest( l1, 1 ), l1 )
expect_equal( geometries:::rcpp_nest( l1, 2 ), l2 )
expect_equal( geometries:::rcpp_nest( l1, 3 ), l3 )
expect_equal( geometries:::rcpp_nest( l1, 4 ), l4 )
expect_equal( geometries:::rcpp_nest( l1, 5 ), l5 )

expect_equal( geometries:::rcpp_nest( l5, 1 ), l1 )
expect_equal( geometries:::rcpp_nest( l5, 2 ), l2 )
expect_equal( geometries:::rcpp_nest( l5, 3 ), l3 )
expect_equal( geometries:::rcpp_nest( l5, 4 ), l4 )
expect_equal( geometries:::rcpp_nest( l5, 5 ), l5 )


## representative of a POLYGON
l <- list(m, m)

## representative of converting to a MULTIPOLYGON
res <- geometries:::rcpp_nest( l, 2 )
expect_true( length( res ) == 1 )
expect_true( length( res[[1]] ) == 2 )

## No impact, beause it's max-nested at level 1 anyway
## geometries:::gm_dimensions( l )
res <- geometries:::rcpp_nest( l, 1 )
expect_equal( l, res )

# geometries:::gm_dimensions( l )$max_dimension

## No change
expect_equal(
  geometries:::rcpp_nest( l, 0 )
  , l
)

## what about mixed-depth lists
## the 'depth' is relative to the max depth

l <- list(
  1:3
  , list(
    list(3:1)
  )
)

# geometries:::gm_dimensions( l )
# max_dimension == 3
expect_equal(
  geometries:::rcpp_nest( l, 3 )
  , l
)

## relative to the max dimension,
## the first element won't get unnested any further than a single 'list'
## The first element starts at nesting level '1'
## so unnesting it doesn't have any effect
expect_equal(
  geometries:::rcpp_nest( l, 0 )
  , geometries:::rcpp_nest( l, 1 )
)

expect_equal(
  geometries:::rcpp_nest( l, 0 )[[1]]
  , geometries:::rcpp_nest( l, 2 )[[1]]
)


## strings work
l <- list(list(c("a", "b", "c", "d"), c("e", "f", "g", "h")))
expect_equal(
  geometries:::rcpp_nest( l, 1 )
  , l[[1]]
)

## representative of converting to LINESTRINGs
# geometries:::rcpp_nest( l, 1 )
# DOes this make sense?
# LINESTRING is a MATRIX
# so it's nesting is 0
# But if there are more than one, we can't unnest to 2 matrices, because that's not a SEXP
# so it has to be at least a list of matrices
# same with POINTs and MULTIPOINTs


# ## TODO
# ## list of shapes (like a sfc)
# ## Needs to iterate over the list and nest/unnest each shape individually
# l <- list(
#   l1,
#   l2
# )
#
# expect_equal( geometries:::rcpp_nest(l, 3), list( list( l ) ) )

expect_equal( geometries:::index_correct( data.frame(x = 1, y = 2), cols = c(1)), 0 )
expect_equal( geometries:::index_correct( data.frame(x = 1, y = 2), cols = c(2)), 1 )
expect_equal( geometries:::index_correct( data.frame(x = 1, y = 2), cols = c(1,2)), c(0,1) )
expect_equal( geometries:::index_correct( data.frame(x = 1, y = 2), cols = c("x")), 0 )
expect_equal( geometries:::index_correct( data.frame(x = 1, y = 2), cols = c("y")), 1 )
expect_equal( geometries:::index_correct( data.frame(x = 1, y = 2), cols = c("x","y")), c(0,1) )

expect_equal( geometries:::index_correct( matrix(1:4, ncol = 2 ), cols = c(1,2) ), c(0,1) )
df <- data.frame(x = 1:2, y = 3:4); m <- as.matrix( df )
expect_equal( geometries:::index_correct( m , cols = c("x","y") ), c(0,1) )

df <- data.frame(
  id1 = c(1,1,1,1,2,2,2)
  , id2 = c(1,1,2,2,1,1,2)
  , id3 = c(1,2,3,4,1,2,3)
  , x = 1:7
  , y = 1:7
  , z = 1:7
  , m = 1:7
  , a = 1:7
)

expect_error(
  geometries:::rcpp_make_geometries( df, c(0L), c("y"), TRUE, TRUE, FALSE )
  , "geometries - id_columns and geometry_columns must be the same type"
  )

expect_error(
  geometries:::rcpp_make_geometries( df, c(1L), c("y"), TRUE, TRUE, FALSE )
  , "geometries - id_columns and geometry_columns must be the same type"
)

m <- as.matrix( df )

## indexing crash
expect_error(
  gm_geometries(df, c(0L),  c("x","y"), list( class = "my_attr") )
  , "invalid column index"
)


## NULL column ids
expect_error( gm_geometries(df, id_cols = NULL, c("x","y"), list( class = "my_attr") ), "columns can't be NULL")


## single ID, single geometry, no attributes
res <- gm_geometries(df, 1, 4)
expect_true( length( res ) == 2 )
expect_true( ncol( res[[1]] ) == 1 )
expect_true( ncol( res[[2]] ) == 1 )

res <- gm_geometries(m, 1, 4)
expect_true( length( res ) == 2 )
expect_true( ncol( res[[1]] ) == 1 )
expect_true( ncol( res[[2]] ) == 1 )

## single ID, single geometry, attributes
res <- gm_geometries(df, 1, 4, list( class = "my_attr") )
expect_true( length( res ) == 2 )
expect_true( ncol( res[[1]] ) == 1 )
expect_true( ncol( res[[2]] ) == 1 )
expect_true( attr( res[[1]], "class") == "my_attr" )
expect_true( attr( res[[2]], "class") == "my_attr" )

res <- gm_geometries(m, 1, 4, list( class = "my_attr") )
expect_true( length( res ) == 2 )
expect_true( ncol( res[[1]] ) == 1 )
expect_true( ncol( res[[2]] ) == 1 )
expect_true( attr( res[[1]], "class") == "my_attr" )
expect_true( attr( res[[2]], "class") == "my_attr" )

## single ID, multi geometry, no attributes
res <- gm_geometries(df, 1, c(4,5,6,7,8), list( class = "my_attr") )
expect_true( length( res ) == 2 )
expect_true( ncol( res[[1]] ) == 5 )
expect_true( ncol( res[[2]] ) == 5 )

res <- gm_geometries(m, 1, c(4,5,6,7,8), list( class = "my_attr") )
expect_true( length( res ) == 2 )
expect_true( ncol( res[[1]] ) == 5 )
expect_true( ncol( res[[2]] ) == 5 )


## single ID, multi geometry, no attributes
res <- gm_geometries(df, 1, c(4,5,6,7,8), list( class = "my_attr") )
expect_true( length( res ) == 2 )
expect_true( ncol( res[[1]] ) == 5 )
expect_true( ncol( res[[2]] ) == 5 )
expect_true( attr( res[[1]], "class") == "my_attr" )
expect_true( attr( res[[2]], "class") == "my_attr" )

res <- gm_geometries(m, 1, c(4,5,6,7,8), list( class = "my_attr") )
expect_true( length( res ) == 2 )
expect_true( ncol( res[[1]] ) == 5 )
expect_true( ncol( res[[2]] ) == 5 )
expect_true( attr( res[[1]], "class") == "my_attr" )
expect_true( attr( res[[2]], "class") == "my_attr" )

## multi ID, multi geometry, no attributes
res <- gm_geometries(df, c(1,2), c(4,5,6,7,8), list( class = "my_attr") )
expect_true( length( res ) == 2 )
expect_true( length( res[[1]] ) == 2 )
expect_true( length( res[[2]] ) == 2 )

expect_true( ncol( res[[1]][[1]] ) == 5 )
expect_true( ncol( res[[1]][[2]] ) == 5 )

expect_true( ncol( res[[2]][[1]] ) == 5 )
expect_true( ncol( res[[2]][[2]] ) == 5 )

expect_true( attr( res[[1]], "class") == "my_attr" )
expect_true( attr( res[[2]], "class") == "my_attr" )

## attributes not set on inner objects
expect_true( is.null( attr( res[[1]][[1]], "class")  ) )
expect_true( is.null( attr( res[[1]][[2]], "class")  ) )
expect_true( is.null( attr( res[[2]][[1]], "class")  ) )
expect_true( is.null( attr( res[[1]][[2]], "class")  ) )



res <- gm_geometries(m, c(1,2), c(4,5,6,7,8), list( class = "my_attr") )
expect_true( length( res ) == 2 )
expect_true( length( res[[1]] ) == 2 )
expect_true( length( res[[2]] ) == 2 )

expect_true( ncol( res[[1]][[1]] ) == 5 )
expect_true( ncol( res[[1]][[2]] ) == 5 )

expect_true( ncol( res[[2]][[1]] ) == 5 )
expect_true( ncol( res[[2]][[2]] ) == 5 )

expect_true( attr( res[[1]], "class") == "my_attr" )
expect_true( attr( res[[2]], "class") == "my_attr" )

## attributes not set on inner objects
expect_true( is.null( attr( res[[1]][[1]], "class")  ) )
expect_true( is.null( attr( res[[1]][[2]], "class")  ) )
expect_true( is.null( attr( res[[2]][[1]], "class")  ) )
expect_true( is.null( attr( res[[1]][[2]], "class")  ) )

## shapes are closed

l <- list(1:5, 1:5)
df <- data.frame( x = 1:5, y = 1:5 )
expect_equal( geometries:::.test_make_dataframe( l, 5, c("x","y")), df )

# l <- list()
# expect_equal( geometries:::.test_make_dataframe( l, 0, "x"), data.frame(x = numeric() ) )

df <- data.frame(x = 1:5, y = 1:5)
expect_error( geometries:::.test_column_check( df, 1L:4L ), "geometries - number of columns requested is greater than those available")

expect_silent( geometries:::.test_column_check( 1L, 0L ) )
expect_error( geometries:::.test_column_check( 1L, 1L ), "geometries - invalid geometry column index" )
expect_error( geometries:::.test_column_check( 1L, -1L ), "geometries - invalid geometry column index" )



df <- data.frame(x = 1:5, y = 1:5)
expect_error( geometries:::.test_column_positions(df, 1L), "geometries - expecting string vector of column names when finding column positions")
expect_equal( geometries:::.test_column_positions(df, "x"), 0L )
expect_equal( geometries:::.test_column_positions(df, c("y","x")), c(1L, 0L) )

m <- as.matrix( df )
expect_equal( geometries:::.test_column_positions( m, c("x","y") ), c(0L, 1L) )
expect_equal( geometries:::.test_column_positions( m, c("y", "x") ), c(1L, 0L) )
expect_equal( geometries:::.test_column_positions( m, c("x","z") ), c(0L, -1L) )
expect_error( geometries:::.test_column_positions( m, c(0L, 1L) ), "geometries - expecting string vector of column names when finding column positions" )


expect_equal( geometries:::.test_other_columns( df, NULL, NULL ), c(0,1) )
expect_equal( geometries:::.test_other_columns( df, 1L, NULL ), c(0) )
expect_equal( geometries:::.test_other_columns( df, NULL, 0L ), c(1) )
expect_equal( geometries:::.test_other_columns( df, 1L, 1L ), c(0) )
expect_equal( geometries:::.test_other_columns( df, NULL, 1L ), c(0) )
expect_equal( geometries:::.test_other_columns( df, 0L, NULL ), c(1) )

expect_error( geometries:::.test_other_columns( list(), "x" , NULL ), "geometries - unsupported object" )

m[1,1] <- 1.1
expect_equal( geometries:::.test_other_columns( m, NULL, NULL ), c(0, 1) )
expect_equal( geometries:::.test_other_columns( m, "x", NULL ), c("y") )
expect_equal( geometries:::.test_other_columns( m, 0L, NULL ), c(1) )

x <- 1:5
attr <- list(myClass = "myClassAttr")
geometries:::.test_attributes( x, attr )
expect_true( attr( x, "myClass" ) == "myClassAttr" )


## Test that both 'has_been_closed' and any other attributes get attached
## when creating geometries

df <- data.frame(
  id1 = c(1,1,1,1,1,1,1,1,1)
  , id2 = c(1,1,1,1,2,2,2,2,2)
  , x = c(1:8, 5)
  , y = c(1:8, 5)
)

res <- geometries:::rcpp_make_geometries(
  x = df
  , id_cols = c(0L,1L)
  , geometry_cols = c(2L,3L)
  , attributes = list(myClass = "myClass")
  , close = TRUE
  , closed_attribute = FALSE
)

expect_true( attr( res[[1]], "myClass") == "myClass" )
expect_true( is.null( attr( res[[1]][[1]], "has_been_closed") ) )

res <- geometries:::rcpp_make_geometries(
  x = df
  , id_cols = c(0L,1L)
  , geometry_cols = c(2L,3L)
  , attributes = list(myClass = "myClass")
  , close = TRUE
  , closed_attribute = TRUE
)

expect_true( attr( res[[1]], "myClass") == "myClass" )
expect_true( attr( res[[1]][[1]], "closed") == "has_been_closed" )
expect_true( is.null( attr( res[[1]][[2]], "closed") ) )


## has-been_closed not added if close == FALSE
res <- geometries:::rcpp_make_geometries(
  x = df
  , id_cols = c(0L,1L)
  , geometry_cols = c(2L,3L)
  , attributes = list(myClass = "myClass")
  , close = FALSE
  , closed_attribute = TRUE
)

expect_true( attr( res[[1]], "myClass") == "myClass" )
expect_true( is.null( attr( res[[1]][[1]], "closed") ) )

df <- data.frame(
  x = 1L
  , y = 1L
)

mint <- as.matrix( df )

df <- data.frame(
  x = 1.1
  , y = 1
)

mdbl <- as.matrix( df )
lst <- as.list( df )

expect_error( geometries:::.test_sexp_col_int( df, 1 ), "geometries - require either integer or string column indices" )
expect_equal( geometries:::.test_sexp_col_int( df, 0L ), 0 )
expect_equal( geometries:::.test_sexp_col_int( df, 1L ), 1 )
expect_equal( geometries:::.test_sexp_col_int( df, "x" ), 0 )
expect_equal( geometries:::.test_sexp_col_int( df, "y" ), 1 )

expect_equal( geometries:::.test_sexp_col_names( df ), names( df ) )
expect_equal( geometries:::.test_sexp_col_names( mint ), names( df ) )
expect_equal( geometries:::.test_sexp_col_names( mdbl ), names( df ) )
expect_equal( geometries:::.test_sexp_col_names( lst ), names( df ) )
expect_error( geometries:::.test_sexp_col_names( 1:4 ), "geometries - object does not have names" )

expect_equal( geometries:::.test_sexp_n_col( df ), 2 )
expect_equal( geometries:::.test_sexp_n_col( data.frame() ), 0 )
expect_equal( geometries:::.test_sexp_n_col( list(x=1) ), 1 )
expect_equal( geometries:::.test_sexp_n_col( matrix(1:4, ncol = 2) ), 2 )

expect_equal( geometries:::.test_sexp_n_row( 1 ), 1 )
expect_equal( geometries:::.test_sexp_n_row( 1:4 ), 1 )
expect_equal( geometries:::.test_sexp_n_row( data.frame() ), 0 )
expect_equal( geometries:::.test_sexp_n_row( data.frame(x = 1:2) ), 2 )
expect_equal( geometries:::.test_sexp_n_row( list() ), 0 )
expect_equal( geometries:::.test_sexp_n_row( list( data.frame(x = 1:2) ) ), 1 )  ## n_row is not-recursive

expect_equal( geometries:::.test_sexp_length( 1:4 ), 4 )
expect_equal( geometries:::.test_sexp_length( 1L:5L ), 5 )
expect_equal( geometries:::.test_sexp_length( c(T,F,T) ), 3 )
expect_equal( geometries:::.test_sexp_length( list() ), 0 )
expect_equal( geometries:::.test_sexp_length( data.frame( x = 1) ), 1 )
expect_equal( geometries:::.test_sexp_length( c(complex(3), complex(4) ) ), 7 )

df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
other_cols <- geometries:::rcpp_other_columns( df, NULL, NULL, NULL )
expect_equal( other_cols, c(0,1,2) )

m <- matrix( 1:24, ncol = 3 )
other_cols <- geometries:::rcpp_other_columns( m, NULL, NULL, NULL )
expect_equal( other_cols, c(0,1,2))


df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c(2L)  ## c++ index
other_cols <- geometries:::rcpp_other_columns( df, id, NULL, NULL )
expect_equal( other_cols, c(0,1) )

m <- matrix( 1:24, ncol = 3 )
id <- c(2L)
other_cols <- geometries:::rcpp_other_columns( m, id, NULL, NULL )
expect_equal( other_cols, c(0,1))


df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c(0L,2L)  ## c++ index
other_cols <- geometries:::rcpp_other_columns( df, id, NULL, NULL )
expect_equal( other_cols, c(1) )

m <- matrix( 1:24, ncol = 3 )
id <- c(0L,2L)
other_cols <- geometries:::rcpp_other_columns( m, id, NULL, NULL )
expect_equal( other_cols, c(1))

## using names / strings
df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c("z")
other_cols <- geometries:::rcpp_other_columns( df, id, NULL, NULL )
expect_equal( other_cols, c("x","y") )

m <- matrix( 1:24, ncol = 3 )
dimnames(m) <- list(NULL, c("x","y","z") )
id <- c("z")
other_cols <- geometries:::rcpp_other_columns( m, id, NULL, NULL )
expect_equal( other_cols, c("x","y"))

df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c("z","x")
other_cols <- geometries:::rcpp_other_columns( df, id, NULL, NULL )
expect_equal( other_cols, c("y") )

m <- matrix( 1:24, ncol = 3 )
dimnames(m) <- list(NULL, c("x","y","z") )
id <- c("z","x")
other_cols <- geometries:::rcpp_other_columns( m, id, NULL, NULL )
expect_equal( other_cols, c("y"))




df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c(2L)  ## c++ index
other_cols <- geometries:::rcpp_other_columns( df, NULL, id, NULL )
expect_equal( other_cols, c(0,1) )

m <- matrix( 1:24, ncol = 3 )
id <- c(2L)
other_cols <- geometries:::rcpp_other_columns( m, NULL, id, NULL )
expect_equal( other_cols, c(0,1))


df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c(0L,2L)  ## c++ index
other_cols <- geometries:::rcpp_other_columns( df, NULL, id, NULL )
expect_equal( other_cols, c(1) )

m <- matrix( 1:24, ncol = 3 )
id <- c(0L,2L)
other_cols <- geometries:::rcpp_other_columns( m, NULL, id, NULL )
expect_equal( other_cols, c(1))

## using names / strings
df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c("z")
other_cols <- geometries:::rcpp_other_columns( df, NULL, id, NULL )
expect_equal( other_cols, c("x","y") )

m <- matrix( 1:24, ncol = 3 )
dimnames(m) <- list(NULL, c("x","y","z") )
id <- c("z")
other_cols <- geometries:::rcpp_other_columns( m, NULL, id, NULL )
expect_equal( other_cols, c("x","y"))

df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c("z","x")
other_cols <- geometries:::rcpp_other_columns( df, NULL, id, NULL )
expect_equal( other_cols, c("y") )

m <- matrix( 1:24, ncol = 3 )
dimnames(m) <- list(NULL, c("x","y","z") )
id <- c("z","x")
other_cols <- geometries:::rcpp_other_columns( m, NULL, id, NULL )
expect_equal( other_cols, c("y"))



df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c(2L)  ## c++ index
other_cols <- geometries:::rcpp_other_columns( df, NULL, NULL, id )
expect_equal( other_cols, c(0,1) )

m <- matrix( 1:24, ncol = 3 )
id <- c(2L)
other_cols <- geometries:::rcpp_other_columns( m, NULL, NULL, id )
expect_equal( other_cols, c(0,1))


df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c(0L,2L)  ## c++ index
other_cols <- geometries:::rcpp_other_columns( df, NULL, NULL, id )
expect_equal( other_cols, c(1) )

m <- matrix( 1:24, ncol = 3 )
id <- c(0L,2L)
other_cols <- geometries:::rcpp_other_columns( m, NULL, NULL, id )
expect_equal( other_cols, c(1))

## using names / strings
df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c("z")
other_cols <- geometries:::rcpp_other_columns( df, NULL, NULL, id )
expect_equal( other_cols, c("x","y") )

m <- matrix( 1:24, ncol = 3 )
dimnames(m) <- list(NULL, c("x","y","z") )
id <- c("z")
other_cols <- geometries:::rcpp_other_columns( m, NULL, NULL, id )
expect_equal( other_cols, c("x","y"))

df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c("z","x")
other_cols <- geometries:::rcpp_other_columns( df, NULL, NULL, id )
expect_equal( other_cols, c("y") )

m <- matrix( 1:24, ncol = 3 )
dimnames(m) <- list(NULL, c("x","y","z") )
id <- c("z","x")
other_cols <- geometries:::rcpp_other_columns( m, NULL, NULL, id )
expect_equal( other_cols, c("y"))



df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c("z")
id2 <- c("y")
other_cols <- geometries:::rcpp_other_columns( df, id, id2, NULL )
expect_equal( other_cols, c("x") )

df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c("z")
id2 <- c("y","x")
other_cols <- geometries:::rcpp_other_columns( df, id, id2, NULL )
expect_equal( other_cols, character() )

df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c(0L)
id2 <- c(1L,2L)
other_cols <- geometries:::rcpp_other_columns( df, id, id2, NULL )
expect_equal( other_cols, numeric() )



df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c("z")
id2 <- c("y")
other_cols <- geometries:::rcpp_other_columns( df, NULL, id, id2 )
expect_equal( other_cols, c("x") )

df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c("z")
id2 <- c("y","x")
other_cols <- geometries:::rcpp_other_columns( df, NULL, id, id2 )
expect_equal( other_cols, character() )

df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c(0L)
id2 <- c(1L,2L)
other_cols <- geometries:::rcpp_other_columns( df, NULL, id, id2 )
expect_equal( other_cols, numeric() )




df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c("z")
id2 <- c("y")
other_cols <- geometries:::rcpp_other_columns( df, id, NULL, id2 )
expect_equal( other_cols, c("x") )

df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c("z")
id2 <- c("y","x")
other_cols <- geometries:::rcpp_other_columns( df, id, NULL, id2 )
expect_equal( other_cols, character() )

df <- data.frame(x = 1:2, y = 3:4, z = 5:6 )
id <- c(0L)
id2 <- c(1L,2L)
other_cols <- geometries:::rcpp_other_columns( df, id, NULL, id2 )
expect_equal( other_cols, numeric() )




df <- data.frame(x = 1:2, y = 3:4, z = 5:6, m = 7:8 )
id <- c(0L)
id2 <- c(1L,2L)
id3 <- c(3L)
other_cols <- geometries:::rcpp_other_columns( df, id, id2, id3 )
expect_equal( other_cols, numeric() )

df <- data.frame(x = 1:2, y = 3:4, z = 5:6, m = 7:8, id = 1:2 )
id <- c(0L)
id2 <- c(1L,2L)
id3 <- c(3L)
other_cols <- geometries:::rcpp_other_columns( df, id, id2, id3 )
expect_equal( other_cols, c(4) )

df <- data.frame(x = 1:2, y = 3:4, z = 5:6, m = 7:8, id = 1:2 )
id <- c(0L)
id2 <- c(0L)
id3 <- c(0L)
other_cols <- geometries:::rcpp_other_columns( df, id, id2, id3 )
expect_equal( other_cols, c(1,2,3,4) )


### -----
### vectors

expect_equal( geometries:::rcpp_concatenate_vectors(1L,5L), c(1L,5L))
expect_equal( geometries:::rcpp_concatenate_vectors(1,5), c(1,5))
expect_equal( geometries:::rcpp_concatenate_vectors(1.2,5), c(1.2,5))
expect_equal( geometries:::rcpp_concatenate_vectors("a","b"), c("a","b"))
expect_error( geometries:::rcpp_concatenate_vectors(1,"a"), "geometries - different vector types found")

expect_equal( geometries:::rcpp_concatenate_vectors(c(1L,2L), c(3L)), c(1L:3L))
expect_equal( geometries:::rcpp_concatenate_vectors(c(1L,2L), c(3L,4L)), c(1L:4L))
expect_equal( geometries:::rcpp_concatenate_vectors(c("a","b"), c("c","d")), c("a","b","c","d"))

### ------
### columns

df <- data.frame(
  a = 1L:3L
  , b = 4L:6
)
m <- as.matrix( df )
expect_equal( geometries:::rcpp_column_positions( m, c("a") ), c(0) )
expect_equal( geometries:::rcpp_column_positions( m, c("a","b") ), c(0,1) )

df <- data.frame(
  a = 1.3
  , b = 4.6
)
m <- as.matrix( df )
expect_equal( geometries:::rcpp_column_positions( m, c("a") ), c(0) )
expect_equal( geometries:::rcpp_column_positions( m, c("a","b") ), c(0,1) )

sv <- c("hello", "world")
expect_equal( geometries:::rcpp_where_is( "hello" , sv ), 0L )
expect_equal( geometries:::rcpp_where_is( "world" , sv ), 1L )
expect_equal( geometries:::rcpp_where_is( "foo" , sv ), -1L )


m <- matrix(1L:4L, ncol = 2)
expect_equal( geometries:::rcpp_get_ids( m, 0L ), c(1L:2L) )

m <- matrix(c(1.2, 2,3,4), ncol = 2)
expect_equal( geometries:::rcpp_get_ids( m, 0L ), c(1.2,2) )

m <- matrix(1L:4L, ncol = 2)
df <- as.data.frame(m)
m <- as.matrix(m)
expect_equal( geometries:::rcpp_get_ids( m, 0L ), c(1L:2L) )
expect_equal( geometries:::rcpp_get_ids( m, "V1" ), c(1L:2L) )

m <- matrix(c(1.2, 2,3,4), ncol = 2)
df <- as.data.frame(m)
m <- as.matrix(m)
expect_equal( geometries:::rcpp_get_ids( m, 0L ), c(1.2,2) )
expect_equal( geometries:::rcpp_get_ids( m, "V1" ), c(1.2,2) )

df <- data.frame(
  x = c(1,1,2,2,3)
  , y = c("a","a","a","b","a")
  , z = I(list(1,2,3,4,5))
  , a = c(T,T,T,T,T)
)


expect_equal( geometries:::rcpp_rleid( df, c(0L)), c(1,1,2,2,3) )
expect_equal( geometries:::rcpp_rleid( df, c(3L)), c(1,1,1,1,1) )
expect_equal( geometries:::rcpp_rleid( df, c(1L)), c(1,1,1,2,3) )
expect_equal( geometries:::rcpp_rleid( df, c(0L,1L)), c(1,1,2,3,4) )
expect_error( geometries:::rcpp_rleid( df, 2L), "geometries - unsupported id column type" )

expect_equal( geometries:::rcpp_rleid_indices( df$x ), c(0,2,4) )
expect_equal( geometries:::rcpp_rleid_indices( df$y ), c(0,3,4) )
expect_error( geometries:::rcpp_rleid_indices( df$z ), "geometries - unsupported vector type" )

---
title: "geometries"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{geometries}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#"
)
```

```{r setup }
library(geometries)
library(Rcpp)
```


### Header

```
#include "geometries/geometries.hpp"
```

### Functions

```
SEXP make_geometries()
```

## data as geometries

When one thinks of geometries in `R`, one of the most common data structures is the matrix. For example, in the `sf` world, an POINT is a single-row matrix (i.e, a vector)


```
sf::st_point( 1:2 )
POINT (1 2)
```

A LINESTRING is a matrix

```
sf::st_linestring( matrix( c(1,1,1,2,2,2,2,1,1,1), ncol = 2, byrow = T) )
LINESTRING (1 1, 1 2, 2 2, 2 1, 1 1)
```

and a POLYGON is a list of matrices


```
sf::st_polygon( list( matrix( c(1,1,1,2,2,2,2,1,1,1), ncol = 2, byrow = T) ) )
POLYGON ((1 1, 1 2, 2 2, 2 1, 1 1))
```

And to group these into a **collection** you would put each geometry inside a list

```

sf::st_sfc(
  list(
    sf::st_linestring( matrix( c(1,1,1,2,2,2,2,1,1,1), ncol = 2, byrow = T) )
    , sf::st_polygon( list( matrix( c(1,1,1,2,2,2,2,1,1,1), ncol = 2, byrow = T) ) )
  )
)

Geometry set for 2 features 
geometry type:  GEOMETRY
dimension:      XY
bbox:           xmin: 1 ymin: 1 xmax: 2 ymax: 2
CRS:            NA
LINESTRING (1 1, 1 2, 2 2, 2 1, 1 1)
POLYGON ((1 1, 1 2, 2 2, 2 1, 1 1))
```


---


From my limited research (i.e., practically none), I estimate most users will have a `data.frame` and will want to convert it into a collection of geometries. 

For example, take a `data.frame` of `x` and `y` coordinates, and two `id` columns. 


```{r}

df <- data.frame(
  id1 = c( rep(1,12), rep(2, 12) )
  , id2 = c( rep(1:4, each = 3), rep(1:4, each = 3) )
  , x = 1:24
  , y = 24:1
)

df

```

You can think of the ID columns in this example as

- `id1` defines a polygon
- `id2` is each ring inside the polygon

Calling `geometries::make_geometries()` will split this data.frame by these ID columns and put the resulting matrices inside list elements.

```r
cppFunction(
  
  depends = "geometries"
  , includes = '#include "geometries/geometries.hpp"'
  , code = '
    SEXP my_shape( SEXP df, SEXP id_cols, SEXP geometry_cols ) {
      return geometries::make_geometries( df, id_cols, geometry_cols );
    }
  '
  , plugins = "cpp11"
)

my_shape( df, c(0L,1L), c(2L,3L) )

# [[1]]
# [[1]][[1]]
#      [,1] [,2]
# [1,]    1   24
# [2,]    2   23
# [3,]    3   22
# 
# [[1]][[2]]
#      [,1] [,2]
# [1,]    4   21
# [2,]    5   20
# [3,]    6   19
# 
# [[1]][[3]]
#      [,1] [,2]
# [1,]    7   18
# [2,]    8   17
# [3,]    9   16
# 
# [[1]][[4]]
#      [,1] [,2]
# [1,]   10   15
# [2,]   11   14
# [3,]   12   13
# 
# 
# [[2]]
# [[2]][[1]]
#      [,1] [,2]
# [1,]   13   12
# [2,]   14   11
# [3,]   15   10
# 
# [[2]][[2]]
#      [,1] [,2]
# [1,]   16    9
# [2,]   17    8
# [3,]   18    7
# 
# [[2]][[3]]
#      [,1] [,2]
# [1,]   19    6
# [2,]   20    5
# [3,]   21    4
# 
# [[2]][[4]]
#      [,1] [,2]
# [1,]   22    3
# [2,]   23    2
# [3,]   24    1
```



Notice here there are no class attributes on the shapes. In `{geometries}` I only want to provide the tools to build these structures, then each user can define what they mean.

For example, if you want to define a class for each geometry you can supply a list containing a "class" vector as the 4th argument

```r

cppFunction(
  depends = "geometries"
  , includes = '#include "geometries/geometries.hpp"'
  , code = '
    SEXP my_shape( Rcpp::DataFrame df, Rcpp::IntegerVector id_cols, Rcpp::IntegerVector geometry_cols, Rcpp::List class_attributes ) {
      return geometries::make_geometries( df, id_cols, geometry_cols, class_attributes );
    }
  '
  , plugins = "cpp11"
)

my_shape( df, c(0,1), c(2,3), list(class = "my_polygon") )

# [[1]]
# [[1]]
#      [,1] [,2]
# [1,]    1   24
# [2,]    2   23
# [3,]    3   22
# 
# [[2]]
#      [,1] [,2]
# [1,]    4   21
# [2,]    5   20
# [3,]    6   19
# 
# [[3]]
#      [,1] [,2]
# [1,]    7   18
# [2,]    8   17
# [3,]    9   16
# 
# [[4]]
#      [,1] [,2]
# [1,]   10   15
# [2,]   11   14
# [3,]   12   13
# 
# attr(,"class")
# [1] "my_polygon"
# 
# [[2]]
# [[1]]
#      [,1] [,2]
# [1,]   13   12
# [2,]   14   11
# [3,]   15   10
# 
# [[2]]
#      [,1] [,2]
# [1,]   16    9
# [2,]   17    8
# [3,]   18    7
# 
# [[3]]
#      [,1] [,2]
# [1,]   19    6
# [2,]   20    5
# [3,]   21    4
# 
# [[4]]
#      [,1] [,2]
# [1,]   22    3
# [2,]   23    2
# [3,]   24    1
# 
# attr(,"class")
# [1] "my_polygon"

```

Notice here that each list element now has a `"my_polygon"` class.

And if you have `library(sf)` loaded, setting the class as `sfg` `POLYGON`, you should see each element printed in the usual `sf` way

```
library(sf)
my_shape( df, c(0,1), c(2,3), list( class = c("XY", "POLYGON","sfg") ) )

# [[1]]
# POLYGON ((1 24, 2 23, 3 22), (4 21, 5 20, 6 19), (7 18, 8 17, 9 16), (10 15, 11 14, 12 13))
# 
# [[2]]
# POLYGON ((13 12, 14 11, 15 10), (16 9, 17 8, 18 7), (19 6, 20 5, 21 4), (22 3, 23 2, 24 1))

```

You can use this function to define any shape you want. The number of `id` columns you supply will determine how deeply nested the matrices are. If I add two more `id` columns, this will nest each matrix 2-levels deeper


```r

df$id0 <- 1
df$id00 <- 1
head( df ) 

my_shape( df, c(0,1,4,5), c(2,3), list(class = "my_new_shape") )

# [[1]]
# [[1]]
# [[1]][[1]]
# [[1]][[1]][[1]]
#      [,1] [,2]
# [1,]    1   24
# [2,]    2   23
# [3,]    3   22
# 
# 
# 
# [[2]]
# [[2]][[1]]
# [[2]][[1]][[1]]
#      [,1] [,2]
# [1,]    4   21
# [2,]    5   20
# [3,]    6   19
# 
# 
# 
# [[3]]
# [[3]][[1]]
# [[3]][[1]][[1]]
#      [,1] [,2]
# [1,]    7   18
# [2,]    8   17
# [3,]    9   16
# 
# 
# 
# [[4]]
# [[4]][[1]]
# [[4]][[1]][[1]]
#      [,1] [,2]
# [1,]   10   15
# [2,]   11   14
# [3,]   12   13
# 
# 
# 
# attr(,"class")
# [1] "my_new_shape"
# 
# [[2]]
# [[1]]
# [[1]][[1]]
# [[1]][[1]][[1]]
#      [,1] [,2]
# [1,]   13   12
# [2,]   14   11
# [3,]   15   10
# 
# 
# 
# [[2]]
# [[2]][[1]]
# [[2]][[1]][[1]]
#      [,1] [,2]
# [1,]   16    9
# [2,]   17    8
# [3,]   18    7
# 
# 
# 
# [[3]]
# [[3]][[1]]
# [[3]][[1]][[1]]
#      [,1] [,2]
# [1,]   19    6
# [2,]   20    5
# [3,]   21    4
# 
# 
# 
# [[4]]
# [[4]][[1]]
# [[4]][[1]][[1]]
#      [,1] [,2]
# [1,]   22    3
# [2,]   23    2
# [3,]   24    1
# 
# 
# 
# attr(,"class")
# [1] "my_new_shape"

```
